clang 10.0.0git

Public Types | Public Member Functions | Public Attributes | List of all members
clang::comments::CommandInfo Struct Reference

Information about a single command. More...

`#include "clang/AST/CommentCommandTraits.h"`

Collaboration diagram for clang::comments::CommandInfo:
[legend]

## Public Types
enum | { NumCommandIDBits = 20 }
| DRY definition of the number of bits used for a command ID. More...

## Public Member Functions
unsigned | getID () const

## Public Attributes
const char * | Name
const char * | EndCommandName
| Name of the command that ends the verbatim block. More...
unsigned | ID: NumCommandIDBits
| The ID of the command. More...
unsigned | NumArgs: 4
| Number of word-like arguments for a given block command, except for \param and \tparam commands – these have special argument parsers. More...
unsigned | IsInlineCommand: 1
| True if this command is a inline command (of any kind). More...
unsigned | IsBlockCommand: 1
| True if this command is a block command (of any kind). More...
unsigned | IsBriefCommand: 1
| True if this command is introducing a brief documentation paragraph ( an alias). More...
unsigned | IsReturnsCommand: 1
| True if this command is \returns or an alias. More...
unsigned | IsParamCommand: 1
| True if this command is introducing documentation for a function parameter (\param or an alias). More...
unsigned | IsTParamCommand: 1
| True if this command is introducing documentation for a template parameter (\tparam or an alias). More...
unsigned | IsThrowsCommand: 1
| True if this command is \throws or an alias. More...
unsigned | IsDeprecatedCommand: 1
| True if this command is \deprecated or an alias. More...
unsigned | IsHeaderfileCommand: 1
| True if this is a \headerfile-like command. More...
unsigned | IsEmptyParagraphAllowed: 1
| True if we don't want to warn about this command being passed an empty paragraph. More...
unsigned | IsVerbatimBlockCommand: 1
| True if this command is a verbatim-like block command. More...
unsigned | IsVerbatimBlockEndCommand: 1
| True if this command is an end command for a verbatim-like block. More...
unsigned | IsVerbatimLineCommand: 1
| True if this command is a verbatim line command. More...
unsigned | IsDeclarationCommand: 1
| True if this command contains a declaration for the entity being documented. More...
unsigned | IsFunctionDeclarationCommand: 1
| True if verbatim-like line command is a function declaration. More...
unsigned | IsRecordLikeDetailCommand: 1
| True if block command is further describing a container API; such as @coclass, @classdesign, etc. More...
unsigned | IsRecordLikeDeclarationCommand: 1
| True if block command is a container API; such as @interface. More...
unsigned | IsUnknownCommand: 1
| True if this command is unknown. More...

## Detailed Description

Information about a single command.

When reordering, adding or removing members please update the corresponding TableGen backend.

Definition at line 32 of file CommentCommandTraits.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

DRY definition of the number of bits used for a command ID.

Enumerator
NumCommandIDBits |

Definition at line 43 of file CommentCommandTraits.h.

## Member Function Documentation

## ◆ getID()

unsigned clang::comments::CommandInfo::getID | ( |  | ) | const
| inline

Definition at line 33 of file CommentCommandTraits.h.

References ID.

Referenced by clang::comments::Sema::actOnUnknownCommand(), and clang::comments::Parser::parseParagraphOrBlockCommand().

## Member Data Documentation

## ◆ EndCommandName

const char* clang::comments::CommandInfo::EndCommandName

Name of the command that ends the verbatim block.

Definition at line 40 of file CommentCommandTraits.h.

## ◆ ID

unsigned clang::comments::CommandInfo::ID

The ID of the command.

Definition at line 46 of file CommentCommandTraits.h.

Referenced by getID().

## ◆ IsBlockCommand

unsigned clang::comments::CommandInfo::IsBlockCommand

True if this command is a block command (of any kind).

Definition at line 56 of file CommentCommandTraits.h.

Referenced by clang::comments::BriefParser::Parse(), clang::comments::Parser::parseParagraphOrBlockCommand(), and clang::comments::CommandTraits::registerBlockCommand().

## ◆ IsBriefCommand

unsigned clang::comments::CommandInfo::IsBriefCommand

True if this command is introducing a brief documentation paragraph ( an alias).

Definition at line 60 of file CommentCommandTraits.h.

Referenced by clang::comments::Sema::checkBlockCommandDuplicate(), and clang::comments::BriefParser::Parse().

## ◆ IsDeclarationCommand

unsigned clang::comments::CommandInfo::IsDeclarationCommand

True if this command contains a declaration for the entity being documented.

For example:

\fn void f(int a);

Definition at line 108 of file CommentCommandTraits.h.

## ◆ IsDeprecatedCommand

unsigned clang::comments::CommandInfo::IsDeprecatedCommand

True if this command is \deprecated or an alias.

Definition at line 77 of file CommentCommandTraits.h.

## ◆ IsEmptyParagraphAllowed

unsigned clang::comments::CommandInfo::IsEmptyParagraphAllowed

True if we don't want to warn about this command being passed an empty paragraph.

Meaningful only for block commands.

Definition at line 84 of file CommentCommandTraits.h.

## ◆ IsFunctionDeclarationCommand

unsigned clang::comments::CommandInfo::IsFunctionDeclarationCommand

True if verbatim-like line command is a function declaration.

Definition at line 111 of file CommentCommandTraits.h.

Referenced by clang::comments::Sema::checkFunctionDeclVerbatimLine().

## ◆ IsHeaderfileCommand

unsigned clang::comments::CommandInfo::IsHeaderfileCommand

True if this is a \headerfile-like command.

Definition at line 80 of file CommentCommandTraits.h.

Referenced by clang::comments::Sema::checkBlockCommandDuplicate().

## ◆ IsInlineCommand

unsigned clang::comments::CommandInfo::IsInlineCommand

True if this command is a inline command (of any kind).

Definition at line 53 of file CommentCommandTraits.h.

Referenced by clang::comments::Parser::parseParagraphOrBlockCommand().

## ◆ IsParamCommand

unsigned clang::comments::CommandInfo::IsParamCommand

True if this command is introducing documentation for a function parameter (\param or an alias).

Definition at line 67 of file CommentCommandTraits.h.

Referenced by clang::comments::Parser::parseBlockCommand().

## ◆ IsRecordLikeDeclarationCommand

unsigned clang::comments::CommandInfo::IsRecordLikeDeclarationCommand

True if block command is a container API; such as @interface.

Definition at line 118 of file CommentCommandTraits.h.

Referenced by clang::comments::Sema::checkContainerDeclVerbatimLine().

## ◆ IsRecordLikeDetailCommand

unsigned clang::comments::CommandInfo::IsRecordLikeDetailCommand

True if block command is further describing a container API; such as @coclass, @classdesign, etc.

Definition at line 115 of file CommentCommandTraits.h.

Referenced by clang::comments::Sema::checkContainerDecl().

## ◆ IsReturnsCommand

unsigned clang::comments::CommandInfo::IsReturnsCommand

True if this command is \returns or an alias.

Definition at line 63 of file CommentCommandTraits.h.

Referenced by clang::comments::BriefParser::Parse().

## ◆ IsThrowsCommand

unsigned clang::comments::CommandInfo::IsThrowsCommand

True if this command is \throws or an alias.

Definition at line 74 of file CommentCommandTraits.h.

## ◆ IsTParamCommand

unsigned clang::comments::CommandInfo::IsTParamCommand

True if this command is introducing documentation for a template parameter (\tparam or an alias).

Definition at line 71 of file CommentCommandTraits.h.

Referenced by clang::comments::Parser::parseBlockCommand().

## ◆ IsUnknownCommand

unsigned clang::comments::CommandInfo::IsUnknownCommand

True if this command is unknown.

This `CommandInfo` object was created during parsing.

Definition at line 122 of file CommentCommandTraits.h.

Referenced by clang::comments::Parser::parseParagraphOrBlockCommand(), and clang::comments::CommandTraits::registerUnknownCommand().

## ◆ IsVerbatimBlockCommand

unsigned clang::comments::CommandInfo::IsVerbatimBlockCommand

True if this command is a verbatim-like block command.

A verbatim-like block command eats every character (except line starting decorations) until matching end command is seen or comment end is hit.

Definition at line 90 of file CommentCommandTraits.h.

## ◆ IsVerbatimBlockEndCommand

unsigned clang::comments::CommandInfo::IsVerbatimBlockEndCommand

True if this command is an end command for a verbatim-like block.

Definition at line 93 of file CommentCommandTraits.h.

Referenced by clang::comments::Parser::parseParagraphOrBlockCommand().

## ◆ IsVerbatimLineCommand

unsigned clang::comments::CommandInfo::IsVerbatimLineCommand

True if this command is a verbatim line command.

A verbatim-like line command eats everything until a newline is seen or comment end is hit.

Definition at line 99 of file CommentCommandTraits.h.

## ◆ Name

const char* clang::comments::CommandInfo::Name

Definition at line 37 of file CommentCommandTraits.h.

Referenced by clang::comments::Sema::actOnInlineCommand(), clang::comments::Sema::actOnVerbatimBlockStart(), clang::TextNodeDumper::dumpDeclRef(), clang::comments::InlineCommandComment::getCommandName(), clang::comments::BlockCommandComment::getCommandName(), clang::comments::Parser::parseParagraphOrBlockCommand(), clang::comments::Parser::parseVerbatimBlock(), and clang::JSONNodeDumper::VisitPackTemplateArgument().

## ◆ NumArgs

unsigned clang::comments::CommandInfo::NumArgs

Number of word-like arguments for a given block command, except for \param and \tparam commands – these have special argument parsers.

Definition at line 50 of file CommentCommandTraits.h.

Referenced by clang::comments::Parser::parseBlockCommand().

The documentation for this struct was generated from the following file:

- include/clang/AST/CommentCommandTraits.h